logmode +addin

'check that an object exists
%type =@getthistype
if %type="NONE" then
        @uiprompt("No object found, please open a GRAPH object.")
        stop
endif

'check that _this object is a graph
if %type<>"GRAPH" then
        @uiprompt("Procedure can only be run from a GRAPH object.")
        stop
endif

'check to see if the frequency is quarterly
if @pagefreq="Q" then
call shadeUSRecessionsQ(_this)
else
call shadeUSRecessions(_this)
endif

subroutine shadeUSRecessions(graph g1)
        g1.draw(shade,bottom) 1857/06/01 1858/12/01
        g1.draw(shade,bottom) 1860/10/01 1861/06/01
        g1.draw(shade,bottom) 1865/04/01 1867/12/01
        g1.draw(shade,bottom) 1869/06/01 1870/12/01
        g1.draw(shade,bottom) 1873/10/01 1879/03/01
        g1.draw(shade,bottom) 1882/03/01 1885/05/01
        g1.draw(shade,bottom) 1887/03/01 1888/04/01
        g1.draw(shade,bottom) 1890/07/01 1891/05/01
        g1.draw(shade,bottom) 1893/01/01 1894/06/01
        g1.draw(shade,bottom) 1895/12/01 1897/06/01
        g1.draw(shade,bottom) 1899/06/01 1900/12/01
        g1.draw(shade,bottom) 1902/09/01 1904/08/01
        g1.draw(shade,bottom) 1907/05/01 1908/06/01
        g1.draw(shade,bottom) 1910/01/01 1912/01/01
        g1.draw(shade,bottom) 1913/01/01 1914/12/01
        g1.draw(shade,bottom) 1918/08/01 1919/03/01
        g1.draw(shade,bottom) 1920/01/01 1921/07/01
        g1.draw(shade,bottom) 1923/05/01 1924/07/01
        g1.draw(shade,bottom) 1926/10/01 1927/11/01
        g1.draw(shade,bottom) 1929/08/01 1933/03/01
        g1.draw(shade,bottom) 1937/05/01 1938/06/01
        g1.draw(shade,bottom) 1945/02/01 1945/10/01
        g1.draw(shade,bottom) 1948/11/01 1949/10/01
        g1.draw(shade,bottom) 1953/07/01 1954/05/01
        g1.draw(shade,bottom) 1957/08/01 1958/04/01
        g1.draw(shade,bottom) 1960/04/01 1961/02/01
        g1.draw(shade,bottom) 1969/12/01 1970/11/01
        g1.draw(shade,bottom) 1973/11/01 1975/03/01
        g1.draw(shade,bottom) 1980/01/01 1980/07/01
        g1.draw(shade,bottom) 1981/07/01 1982/11/01
        g1.draw(shade,bottom) 1990/07/01 1991/03/01
        g1.draw(shade,bottom) 2001/03/01 2001/11/01
        g1.draw(shade,bottom) 2007/12/01 2009/06/01
        g1.draw(shade,bottom) 2020/02/01 2020/04/01         
endsub

subroutine shadeUSRecessionsQ(graph g1)
        g1.draw(shade,bottom) 1857Q2 1858Q4
        g1.draw(shade,bottom) 1860Q3 1861Q3
        g1.draw(shade,bottom) 1865Q1 1867Q1
        g1.draw(shade,bottom) 1869Q2 1870Q4
        g1.draw(shade,bottom) 1873Q3 1879Q1
        g1.draw(shade,bottom) 1882Q1 1885Q2
        g1.draw(shade,bottom) 1887Q2 1888Q1
        g1.draw(shade,bottom) 1890Q3 1891Q2
        g1.draw(shade,bottom) 1893Q1 1894Q2
        g1.draw(shade,bottom) 1895Q4 1897Q2
        g1.draw(shade,bottom) 1899Q3 1900Q4
        g1.draw(shade,bottom) 1902Q4 1904Q3
        g1.draw(shade,bottom) 1907Q2 1908Q2
        g1.draw(shade,bottom) 1910Q1 1912Q4
        g1.draw(shade,bottom) 1913Q1 1914Q4
        g1.draw(shade,bottom) 1918Q3 1919Q1
        g1.draw(shade,bottom) 1920Q1 1921Q3
        g1.draw(shade,bottom) 1923Q2 1924Q3
        g1.draw(shade,bottom) 1926Q3 1927Q4
        g1.draw(shade,bottom) 1929Q3 1933Q1
        g1.draw(shade,bottom) 1937Q2 1938Q2
        g1.draw(shade,bottom) 1945Q1 1945Q4
        g1.draw(shade,bottom) 1948Q4 1949Q4
        g1.draw(shade,bottom) 1953Q2 1954Q2
        g1.draw(shade,bottom) 1957Q3 1958Q2
        g1.draw(shade,bottom) 1960Q2 1961Q1
        g1.draw(shade,bottom) 1969Q4 1970Q4
        g1.draw(shade,bottom) 1973Q4 1975Q1
        g1.draw(shade,bottom) 1980Q1 1980Q3
        g1.draw(shade,bottom) 1981Q3 1982Q4
        g1.draw(shade,bottom) 1990Q3 1991Q1
        g1.draw(shade,bottom) 2001Q1 2001Q4
        g1.draw(shade,bottom) 2007Q4 2009Q2
        g1.draw(shade,bottom) 2019Q4 2020Q2
endsub


